/*
 * Created on 2005. 4. 20
 */
package org.manalith.manager;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;


import org.apache.log4j.Logger;
import org.manalith.db.ConnectionFactory;
import org.manalith.resource.VisitorLog;
import org.postgresql.util.PGobject;

/**
 * @author setzer
 */
public class VisitorLogManager {
    private Connection conn;
    private static VisitorLogManager manager;
    private static Logger logger = Logger.getLogger(VisitorLogManager.class);
    
    private VisitorLogManager(){
        try {
            conn = ConnectionFactory.getConnection();
        } catch (SQLException ex) {
            logger.error("SQLException: " + ex.getMessage()); 
            logger.error("SQLState: " + ex.getSQLState()); 
            logger.error("VendorError: " + ex.getErrorCode()); 
        }
    }
    
    public static VisitorLogManager instance(){
        if(manager == null){
            manager = new VisitorLogManager();
        }
        return manager;
    }
    
    public void addLog(VisitorLog vLog){
        PreparedStatement pstmt = null;
        StringBuffer sb = new StringBuffer();
        sb.append("INSERT INTO manalith_blog_log(blogOwnerId, ip, referer, agent) ");
        sb.append("VALUES(?,?,?,?)");
        
        try{
            //FIXME 중복된 로그를 저장하지 않도록
            
            pstmt = conn.prepareStatement(sb.toString());
            pstmt.setString(1,vLog.getBlogOwnerId());
            
            //FIXME inet형을 pgsql7.4대의 jdbc 드라이버처럼 string 으로 입력하도록
            PGobject inet = new PGobject();
            inet.setType("inet");
            inet.setValue(vLog.getIp());
            pstmt.setObject(2,inet);
            
            pstmt.setString(3,vLog.getReferer());
            pstmt.setString(4,vLog.getAgent());
            
            pstmt.executeUpdate();
        } catch (SQLException e) {
            logger.error(e);
        } catch (ClassCastException e) {
            logger.error(e);
        } finally {
            if (pstmt != null) {
                try {
                    pstmt.close(); 
                } catch (SQLException e) {
        	        logger.error(e.toString());
                }
                pstmt = null; 
            } 
        }
    }
}
